All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.servlet.tbeans.graphics
Class BaseESRIMapChart

    com.sas.servlet.tbeans.graphics.BaseESRIMapChart

All Implemented Interfaces:
  ActionProviderViewInterface, HttpActionProviderInterface, HttpActionProviderViewInterface, com.sas.beans.PropertyChangeSource, com.sas.lang.ObjectDataInterface, com.sas.servlet.tbeans.features.FeatureListInterface, RenderableInterface, TransformationInterface, com.sas.util.WriteToPrintWriterInterface, java.io.Serializable

Direct Known Subclasses:
  ESRIMapChart, OLAPESRIMapChart

    @SASScope(value="ALL")
    public abstract class BaseESRIMapChart

BaseESRIMapChart is a base class for the OLAP and relational ESRIMap tbeans. It contains the shared features of the two classes.

Note. This class contains an ESRIMapDataModel for the ESRIMap's data properties, and an ESRIMapModel for it's presentation properties.

It is also possible to directly use the image renderer class, com.sas.graphics.map.ESRIMap class.

See Also:
  `ESRIMapModel`, `ESRIMapDataModel`, `OLAPESRIMapChart`, `GraphStyle`, Serialized Form

Field Summary
`protected GraphStyle` | `graphStyle`
`protected java.awt.Dimension` | `legendSize`
`protected int` | `mode`

Constructor Summary
`BaseESRIMapChart()` Creates a new, empty instance of the (abstract) BaseESRIMapChart

Method Summary
`void` | `applyGraphStyle(GraphStyle style)` Applies a GraphStyle object to the map.
`ESRIMapDataModel` | `getDataModel()` Returns the current data model.
`java.util.HashMap` | `getDefaultLayerVisibilities()` Gets a list of the layers available on the map service, and a value indicating their default visibility.
`ESRIMapModel` | `getGraphModel()` Returns the ESRIMapModel that is currently being used to control the map's display properties.
`java.lang.String` | `getImageLocation()` Returns the image location used by the map.
`java.util.HashMap` | `getLayerVisibilities()` Gets a list of the layers available on the map service, and a value indicating their visibility.
`byte[]` | `getLegendImageMimeData()` Returns the MIME image data for the most recently rendered legend.
`java.awt.Dimension` | `getLegendSize()` This is a convenience method used to retrieve the previously-calculated legend size.
`java.util.Locale` | `getLocale()` Returns the Locale
`double[]` | `getMapExtents()` Returns the current extents of the displayed map.
`byte[]` | `getMapImageMimeData()` Returns the MIME image data for the last rendered map
`java.awt.Dimension` | `getMapSize()` This is a convenience method used to retrieve the previously-calculated map size.
`java.util.Map` | `getStyleMap()` Returns the styleMap used by the ESRIMapChart.
`boolean` | `isAutoZoom()` Returns whether the map will autozoom during the next refresh.
`boolean` | `isDebug()` Returns whether the map is in debug mode.
`boolean` | `isDisabledImage()` Returns whether the image is currently set to be disabled.
`boolean` | `isRedrawMap()` Returns whether the ESRIMapChart currently needs to be redrawn.
`boolean` | `isUseSession()` Returns whether the map should use the HttpSession object to save needed state.
`abstract void` | `printDebugInfo(ESRIMap map)` Prints out debug information about the component and the passed-in ESRIMap.
`void` | `setAutoZoom(boolean autoZoom)` Sets whether the map should zoom into the extents of the data after some action.
`void` | `setDataModel(ESRIMapDataModel model)` Sets the data model on the viewer.
`void` | `setDebug(boolean debug)` Sets whether the map should print debug information in normal run-time operation.
`void` | `setDisabledImage(boolean disabledImage)` Sets whether the map image tag created should be disabled.
`void` | `setGraphModel(ESRIMapModel m)` Sets a ESRIMapModel to control the map's display properties
`void` | `setImageLocation(java.lang.String imageLocation)` Sets the image location used by the map.
`void` | `setLayerVisibilities(java.util.HashMap hash)` Sets the visibilities of the layers using the passed-in HashMap.
`void` | `setLayerVisibility(java.lang.String layer, java.lang.String visible)` Sets the visibility of the layer.
`void` | `setLocale(java.util.Locale loc)` Sets the Locale.
`void` | `setMapExtents(double[] extents)` Sets the current extents of the displayed map, in map coordinates.
`void` | `setMapExtents(double xmin, double xmax, double ymin, double ymax)` Sets the current extents of the displayed map, in map coordinates.
`void` | `setRedrawMap(boolean redrawMap)` Sets whether the ESRIMapChart should redraw itself, or simply used any avialable cached image.
`void` | `setSize(int width, int height)` This sets the size of the MapChart.
`void` | `setStyleMap(StyleMap styleMap)` Sets the StyleMap on the ESRIMapChart.
`void` | `setUseSavedMapExtents(boolean useSavedMapExtents)` Sets the flag that determines whether the map should use any saved map extents.
`void` | `setUseSession(boolean useSession)` Sets whether the map should use the HttpSession object to save needed state.

Methods inherited from class com.sas.servlet.tbeans.BaseActionTransformation
`dispose, getActionProvider, getActionSupportType, getUniqueId, isActionVisible, listActionTypes, listAreaTypes, setActionProvider, setActionSupportType, setActionVisible, setUniqueId, write`

Methods inherited from class com.sas.servlet.tbeans.BaseTransformation
`addPropertyChangeListener, addPropertyChangeListener, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getCustomAttributes, getDescription, getId, getInputTransform, getName, getObjectData, getObjectDataProperty, getOutputTransform, getRequest, getResponse, getTagEpilog, getTagProlog, hasListeners, isCleanUpResourcesOn, isVisible, removePropertyChangeListener, removePropertyChangeListener, setCleanUpResourcesOn, setCustomAttributes, setDescription, setId, setInputTransform, setLocaleDependentProperties, setName, setObjectData, setObjectDataProperty, setOutputTransform, setRequest, setResponse, setTagEpilog, setTagProlog, setVisible, toString, write, write, write`

Methods inherited from interface com.sas.actionprovider.HttpActionProviderViewInterface
`getRequest, setRequest`

Field Detail

### mode

    protected int mode

### legendSize

    protected java.awt.Dimension legendSize

### graphStyle

    protected GraphStyle graphStyle

Constructor Detail

### BaseESRIMapChart

    public BaseESRIMapChart()

  Creates a new, empty instance of the (abstract) BaseESRIMapChart

Method Detail

### getStyleMap

    public java.util.Map getStyleMap()

  Returns the styleMap used by the ESRIMapChart.

  Returns:
    The styleMap.

### setStyleMap

    public void setStyleMap(StyleMap styleMap)

  Sets the StyleMap on the ESRIMapChart.

  Parameters:
    `styleMap` - The styleMap to set.

### isRedrawMap

    public boolean isRedrawMap()

  Returns whether the ESRIMapChart currently needs to be redrawn.

  Returns:
    Whether to redraw

### setRedrawMap

    public void setRedrawMap(boolean redrawMap)

  Sets whether the ESRIMapChart should redraw itself, or simply used any avialable cached image. This is used to flag those actions which don't force a regeneration of the map data.

  Parameters:
    `redrawMap` -

### isAutoZoom

    public boolean isAutoZoom()

  Returns whether the map will autozoom during the next refresh. AutoZoom will cause the map to set its extents to the extents of the color-mapped data.

  Returns:
    The autoZoom
  See Also:
    `setAutoZoom(boolean)`

### setAutoZoom

    public void setAutoZoom(boolean autoZoom)

  Sets whether the map should zoom into the extents of the data after some action. By default some actions, such as drill and expand events should result in showing only the portion of the map that is colored. This is currently being used by the commands to set the desired behavior for the next map refresh.

  Parameters:
    `autoZoom` - The autoZoom to set.
  See Also:
    `isAutoZoom()`

### setGraphModel

    public void setGraphModel(ESRIMapModel m)

  Sets a ESRIMapModel to control the map's display properties

  Parameters:
    `m` - ESRIMapModel to control the map's display properties

### getGraphModel

    public ESRIMapModel getGraphModel()

  Returns the ESRIMapModel that is currently being used to control the map's display properties.

  Returns:
    ESRIMapModel

### setDataModel

    public void setDataModel(ESRIMapDataModel model)

  Sets the data model on the viewer.

  Parameters:
    `model` - An instance of the ESRIMapDataModel
  See Also:
    `ESRIMapDataModel`

### getDataModel

    public ESRIMapDataModel getDataModel()

  Returns the current data model.

  Returns:
    The data model
  See Also:
    `ESRIMapDataModel`

### setMapExtents

    public void setMapExtents(double xmin,
                              double xmax,
                              double ymin,
                              double ymax)

  Sets the current extents of the displayed map, in map coordinates.

  Parameters:
    `xmin` - Minimum X value
    `xmax` - Maximum X value
    `ymin` - Minimum Y value
    `ymax` - Maximum Y Value

### getMapExtents

    public double[] getMapExtents()

  Returns the current extents of the displayed map. The returned array of doubles is defined to be of the form [xmin,xmax,ymin,ymax].

  Returns:
    The extents

### setMapExtents

    public void setMapExtents(double[] extents)

  Sets the current extents of the displayed map, in map coordinates. The array of doubles is expected to be of the form [xmin,xmax,ymin,ymax].

  Parameters:
    `extents` - The new map extents

### setUseSavedMapExtents

    public void setUseSavedMapExtents(boolean useSavedMapExtents)

  Sets the flag that determines whether the map should use any saved map extents.

  Parameters:
    `useSavedMapExtents` -

### setSize

    public void setSize(int width,
                        int height)

  This sets the size of the MapChart. The overall size is then separated into parts for the map, measure ComboBox, and legend.

  Overrides:
    `setSize` in class `com.sas.servlet.tbeans.graphics.BaseGraphics`
  Parameters:
    `width` - The chart width
    `height` - The chart height
  See Also:
    `BaseGraphics.setSize(int, int)`, `getMapSize()`, `getLegendSize()`

### getMapSize

    public java.awt.Dimension getMapSize()

  This is a convenience method used to retrieve the previously-calculated map size. When a size is set on the MapComponent, the map size is calculated by allocating 75% of the overall width, and 100% of the overall height.

  Returns:
    mapSize

### getLegendSize

    public java.awt.Dimension getLegendSize()

  This is a convenience method used to retrieve the previously-calculated legend size. When a size is set on the MapComponent, the legend size is calculated by allocating 25% of the overall width, and 100% of the overall height, subtracting off space for the measure ComboBox.

  Returns:
    legendSize

### getLegendImageMimeData

    public byte[] getLegendImageMimeData()

  Returns the MIME image data for the most recently rendered legend.

  Returns:
    byte[] MIME image data

### getMapImageMimeData

    public byte[] getMapImageMimeData()

  Returns the MIME image data for the last rendered map

  Returns:
    byte[] MIME image data

### getLayerVisibilities

    public java.util.HashMap getLayerVisibilities()

  Gets a list of the layers available on the map service, and a value indicating their visibility.
  Possible values in the map are:
  - ESRIConnection.ESRI_LAYER_ALWAYSOFF - The indicated layer is never drawn.
  - ESRIConnection.ESRI_LAYER_USEMAPSERVICERULES - The layer is drawn according to map service rules. Thus, at the appropriate height (or zoom level), the layer will appear. This is setup beforehand by the builder of the map service.

  Returns:
    HashMap of the visibilities of each layer
  See Also:
    `setLayerVisibilities(HashMap)`, `setLayerVisibility(String, String)`, `ESRIConnection`

### getDefaultLayerVisibilities

    public java.util.HashMap getDefaultLayerVisibilities()

  Gets a list of the layers available on the map service, and a value indicating their default visibility.
  Possible values in the map are:
  - ESRIConnection.ESRI_LAYER_ALWAYSOFF - The indicated layer is never drawn.
  - ESRIConnection.ESRI_LAYER_USEMAPSERVICERULES - The layer is drawn according to map service rules. Thus, at the appropriate height (or zoom level), the layer will appear. This is setup beforehand by the builder of the map service.

  Returns:
    HashMap of the visibilities of each layer
  See Also:
    `setLayerVisibilities(HashMap)`, `setLayerVisibility(String, String)`, `ESRIConnection`

### setLayerVisibility

    public void setLayerVisibility(java.lang.String layer,
                                   java.lang.String visible)

  Sets the visibility of the layer.

  Parameters:
    `layer` -
    `visible` -
  See Also:
    `setLayerVisibilities(HashMap)`

### setLayerVisibilities

    public void setLayerVisibilities(java.util.HashMap hash)

  Sets the visibilities of the layers using the passed-in HashMap. The map must contain a series of entries where each entry has a key of the layer name, and a value of one of the following:
  - ESRIConnection.ESRI_LAYER_ALWAYSON - The indicated layer is always drawn. This is not currently supported.
  - ESRIConnection.ESRI_LAYER_ALWAYSOFF - The indicated layer is never drawn.
  - ESRIConnection.ESRI_LAYER_USEMAPSERVICERULES - The layer is drawn according to map service rules. Thus, at the appropriate height (or zoom level), the layer will appear. This is setup beforehand by the builder of the map service.

  Parameters:
    `hash` -
  See Also:
    `setLayerVisibility(String, String)`, `getLayerVisibilities()`

### isUseSession

    public boolean isUseSession()

  Returns whether the map should use the HttpSession object to save needed state.

  Returns:
    The useSession.

### setUseSession

    public void setUseSession(boolean useSession)

  Sets whether the map should use the HttpSession object to save needed state.

  Parameters:
    `useSession` - The useSession to set.

### applyGraphStyle

    public void applyGraphStyle(GraphStyle style)

  Applies a GraphStyle object to the map. Currently the map is colored using the three color ramp on the style. Outline color, missing color, selection color, legend font and color, and default map color are all retrieved from the style information.

  Overrides:
    `applyGraphStyle` in class `com.sas.servlet.tbeans.graphics.BaseGraph`
  Parameters:
    `style` - class containing a set of visual attributes for the charts.
  See Also:
    `BaseGraph.applyGraphStyle(com.sas.graphics.components.GraphStyle)`

### setLocale

    public void setLocale(java.util.Locale loc)

  Sets the Locale.

  Specified by:
    `setLocale` in interface `TransformationInterface`
  Overrides:
    `setLocale` in class `BaseTransformation`
  Parameters:
    `loc` - The new Locale to use.

### getLocale

    public java.util.Locale getLocale()

  Returns the Locale

  Specified by:
    `getLocale` in interface `TransformationInterface`
  Overrides:
    `getLocale` in class `BaseTransformation`
  Returns:
    The Locale.

### getImageLocation

    public java.lang.String getImageLocation()

  Returns the image location used by the map.

  Returns:
    Returns the imageLocation.

### setImageLocation

    public void setImageLocation(java.lang.String imageLocation)

  Sets the image location used by the map.

  Parameters:
    `imageLocation` - The imageLocation to set.

### isDisabledImage

    public boolean isDisabledImage()

  Returns whether the image is currently set to be disabled.

  Returns:
    Whether it's disabled
  See Also:
    `setDisabledImage(boolean)`

### setDisabledImage

    public void setDisabledImage(boolean disabledImage)

  Sets whether the map image tag created should be disabled.

  Parameters:
    `disabledImage` - Whether to mark the image as disabled.

### printDebugInfo

    public abstract void printDebugInfo(ESRIMap map)

  Prints out debug information about the component and the passed-in ESRIMap.

  Parameters:
    `map` -

### isDebug

    public boolean isDebug()

  Returns whether the map is in debug mode.

  Returns:
    isDebug

### setDebug

    public void setDebug(boolean debug)

  Sets whether the map should print debug information in normal run-time operation.

  Parameters:
    `debug` - The debug to set.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.